# DoME 5.0 model; type: Projector Diagram
[ProjectorGraph
  nodes: [OrderedCollection
    [ProjectorShelfHolder
      name: 'Shelf Holder'!
      position: [Point 100 100]
      subdiagrams: [OrderedCollection
	[ProjectorArchetypeGraph
	  name: 'Archetypes'!
	  nodes: [OrderedCollection
	    [GraphParentLabel
	      position: [Point 49 35]
	    ]

	    [ProjectorProcedure
	      name: 'generate-alter'!
	      position: [Point 255 259]
	      archetype: [GrapEThingAddress
		id: 4!
	      ]

	      size: [Point 118 41]
	      components: [PartitionedCollection
		key: #accessories!
		value: [PartitionedCollection
		  key: #ports!
		  value: [OrderedCollection
		    [ProjectorDataPort
		      name: 'model'!
		      position: [Point -58 9]
		      id: 65!
		      properties: [GrapEPropertyDictionary
			key: #direction!
			value: #In!
			key: #showName!
			value: true!
		      ]

		    ]

		  ]
		]

	      ]

	      subdiagrams: [OrderedCollection
		[ProjectorGraph
		  nodes: [OrderedCollection
		    [ProjectorGraphLabel
		      position: [Point 77 35]
		    ]

		    [ProjectorDataPort
		      position: [Point 47 118]
		      parentCon: [GrapEThingAddress
			id: 65!
		      ]

		      id: 66!
		    ]

		    [ProjectorAlterCode
		      name: 'get-classes'!
		      position: [Point 158 110]
		      size: [Point 117 47]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'model'!
			      position: [Point -58 8]
			      id: 67!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
				key: #showName!
				value: true!
			      ]

			    ]

			    [ProjectorDataPort
			      name: 'classes'!
			      position: [Point 59 8]
			      id: 74!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #Out!
				key: #showName!
				value: true!
			      ]

			    ]

			  ]
			]

		      ]

		      properties: [GrapEPropertyDictionary
			key: #code!
			value: [GrapEHyperText
			  textWithLinks: [OrderedCollection '(select (nodes model)
  (lambda (n) (is-a? n domainclass)))'!]
			]

		      ]

		    ]

		    [ProjectorProcedure
		      name: 'get-output-port'!
		      position: [Point 156 169]
		      archetype: [GrapEThingAddress
			id: 6!
		      ]

		      size: [Point 117 43]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'port'!
			      position: [Point 59 7]
			      parentCon: [GrapEThingAddress
				id: 7!
			      ]

			      id: 72!
			    ]

			  ]
			]

		      ]

		    ]

		    [ProjectorProcedure
		      name: 'close'!
		      position: [Point 284 226]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'Port1'!
			      position: [Point -23 0]
			      id: 79!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
			      ]

			    ]

			    [ProjectorDataPort
			      position: [Point 24 0]
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #Out!
			      ]

			    ]

			  ]
			]

		      ]

		      id: 81!
		    ]

		    [ProjectorFork
		      position: [Point 228 171]
		      id: 78!
		    ]

		    [ProjectorStatementBlock
		      name: 'write-all-definitions'!
		      position: [Point 367 108]
		      size: [Point 207 153]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'classes'!
			      position: [Point -96 10]
			      id: 93!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
			      ]

			    ]

			    [ProjectorDataPort
			      name: 'port'!
			      position: [Point -96 26]
			      id: 95!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
			      ]

			    ]

			  ]
			]

			key: #elements!
			value: [PartitionedCollection
			  key: #statements!
			  value: [SortedCollection
			    [ProjectorProcedure
			      name: 'write-definition'!
			      position: [Point 22 8]
			      archetype: [GrapEThingAddress
				id: 19!
			      ]

			      size: [Point 124 51]
			      components: [PartitionedCollection
				key: #accessories!
				value: [PartitionedCollection
				  key: #ports!
				  value: [OrderedCollection
				    [ProjectorDataPort
				      name: 'class'!
				      position: [Point -62 2]
				      parentCon: [GrapEThingAddress
					id: 22!
				      ]

				      id: 94!
				    ]

				    [ProjectorDataPort
				      name: 'port'!
				      position: [Point -62 18]
				      parentCon: [GrapEThingAddress
					id: 23!
				      ]

				      id: 96!
				    ]

				  ]
				]

			      ]

			    ]

			  ]
			]

		      ]

		      id: 97!
		    ]

		  ]
		  arcs: [OrderedCollection
		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 66!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 67!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 72!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 78!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 74!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 93!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #transfer!
			value: #simple!
			key: #trace!
			value: false!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 78!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 79!
		      ]

		      route: [OrderedCollection
			[Point 233 226]
		      ]
		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 93!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 94!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #transfer!
			value: #reduce!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 78!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 95!
		      ]

		      route: [OrderedCollection
			[Point 233 134]
		      ]
		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 95!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 96!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #transfer!
			value: #maintain!
		      ]

		    ]

		    [ProjectorControlFlow
		      indexedOrigin: [GrapEThingAddress
			id: 97!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 81!
		      ]

		      color: [ColorValue
			red: 1.0!
			green: 0.0!
			blue: 0.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		  ]
		  currentConfig: 'default'!
		  id: 64!
		  properties: [GrapEPropertyDictionary
		    key: #break!
		    value: true!
		    key: #windowBounds!
		    value: [Rectangle
		      origin: [Point 114 219]
		      corner: [Point 706 580]
		    ]

		  ]

		]

	      ]
	      id: 4!
	    ]

	    [ProjectorProcedure
	      name: 'get-output-port'!
	      position: [Point 251 260]
	      archetype: [GrapEThingAddress
		id: 6!
	      ]

	      size: [Point 117 43]
	      components: [PartitionedCollection
		key: #accessories!
		value: [PartitionedCollection
		  key: #ports!
		  value: [OrderedCollection
		    [ProjectorDataPort
		      name: 'port'!
		      position: [Point 59 7]
		      id: 7!
		      properties: [GrapEPropertyDictionary
			key: #direction!
			value: #Out!
			key: #showName!
			value: true!
		      ]

		    ]

		  ]
		]

	      ]

	      subdiagrams: [OrderedCollection
		[ProjectorGraph
		  nodes: [OrderedCollection
		    [ProjectorGraphLabel
		      position: [Point 81 35]
		    ]

		    [ProjectorDataPort
		      position: [Point 424 194]
		      parentCon: [GrapEThingAddress
			id: 7!
		      ]

		      id: 17!
		    ]

		    [ProjectorProcedure
		      name: 'request-new-file-name'!
		      position: [Point 87 89]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      position: [Point 80 0]
			      id: 8!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #Out!
				key: #showName!
				value: false!
			      ]

			    ]

			  ]
			]

		      ]

		    ]

		    [ProjectorProcedure
		      name: 'nil?'!
		      position: [Point 256 89]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'Port1'!
			      position: [Point -20 0]
			      id: 10!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
			      ]

			    ]

			    [ProjectorDataPort
			      position: [Point 20 0]
			      id: 14!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #Out!
			      ]

			    ]

			  ]
			]

		      ]

		    ]

		    [ProjectorConditional
		      position: [Point 307 134]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorConditionalPort
			      name: 'T'!
			      position: [Point 10 2]
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #Out!
			      ]

			    ]

			    [ProjectorConditionalPort
			      name: 'F'!
			      position: [Point -9 2]
			      id: 12!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #Out!
			      ]

			    ]

			  ]
			]

		      ]

		      id: 15!
		    ]

		    [ProjectorProcedure
		      name: 'open-output-file'!
		      position: [Point 296 194]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'Port1'!
			      position: [Point -62 0]
			      id: 11!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
			      ]

			    ]

			    [ProjectorDataPort
			      position: [Point 62 0]
			      id: 16!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #Out!
			      ]

			    ]

			  ]
			]

		      ]

		      id: 13!
		    ]

		    [ProjectorFork
		      position: [Point 201 84]
		      id: 18!
		    ]

		  ]
		  arcs: [OrderedCollection
		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 14!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 15!
		      ]

		      route: [OrderedCollection
			[Point 307 89]
		      ]
		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 16!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 17!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 8!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 18!
		      ]

		    ]

		    [ProjectorControlFlow
		      indexedOrigin: [GrapEThingAddress
			id: 12!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 13!
		      ]

		      color: [ColorValue
			red: 1.0!
			green: 0.0!
			blue: 0.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 18!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 10!
		      ]

		      route: [OrderedCollection
			[Point 232 89]
		      ]
		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 18!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 11!
		      ]

		      route: [OrderedCollection
			[Point 206 194]
		      ]
		    ]

		  ]
		  currentConfig: 'default'!
		  id: 1!
		  properties: [GrapEPropertyDictionary
		    key: #windowBounds!
		    value: [Rectangle
		      origin: [Point 52 301]
		      corner: [Point 604 692]
		    ]

		  ]

		]

	      ]
	      id: 6!
	    ]

	    [ProjectorProcedure
	      name: 'write-definition'!
	      position: [Point 251 264]
	      archetype: [GrapEThingAddress
		id: 19!
	      ]

	      size: [Point 124 51]
	      components: [PartitionedCollection
		key: #accessories!
		value: [PartitionedCollection
		  key: #ports!
		  value: [OrderedCollection
		    [ProjectorDataPort
		      name: 'class'!
		      position: [Point -62 1]
		      id: 22!
		      properties: [GrapEPropertyDictionary
			key: #direction!
			value: #In!
			key: #showName!
			value: true!
		      ]

		    ]

		    [ProjectorDataPort
		      name: 'port'!
		      position: [Point -62 16]
		      id: 23!
		      properties: [GrapEPropertyDictionary
			key: #direction!
			value: #In!
			key: #showName!
			value: true!
		      ]

		    ]

		  ]
		]

	      ]

	      subdiagrams: [OrderedCollection
		[ProjectorGraph
		  nodes: [OrderedCollection
		    [ProjectorGraphLabel
		      position: [Point 85 36]
		    ]

		    [ProjectorDataPort
		      position: [Point 49 95]
		      parentCon: [GrapEThingAddress
			id: 22!
		      ]

		      id: 29!
		    ]

		    [ProjectorDataPort
		      position: [Point 51 205]
		      parentCon: [GrapEThingAddress
			id: 23!
		      ]

		      id: 31!
		    ]

		    [ProjectorProcedure
		      name: 'write-class-comment'!
		      position: [Point 258 96]
		      archetype: [GrapEThingAddress
			id: 20!
		      ]

		      size: [Point 146 45]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'class'!
			      position: [Point -73 -1]
			      parentCon: [GrapEThingAddress
				id: 24!
			      ]

			      id: 33!
			    ]

			    [ProjectorDataPort
			      name: 'port'!
			      position: [Point -73 13]
			      parentCon: [GrapEThingAddress
				id: 25!
			      ]

			      id: 36!
			    ]

			  ]
			]

		      ]

		      bindings: [Set
			[ModelBinding
			  name: 'default'!
			  model: [GrapEThingAddress
			    id: 92!
			  ]

			]

		      ]
		      id: 37!
		    ]

		    [ProjectorProcedure
		      name: 'write-class-definition'!
		      position: [Point 270 189]
		      archetype: [GrapEThingAddress
			id: 26!
		      ]

		      size: [Point 168 53]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'class'!
			      position: [Point -83 2]
			      parentCon: [GrapEThingAddress
				id: 27!
			      ]

			      id: 35!
			    ]

			    [ProjectorDataPort
			      name: 'port'!
			      position: [Point -84 16]
			      parentCon: [GrapEThingAddress
				id: 28!
			      ]

			      id: 34!
			    ]

			  ]
			]

		      ]

		      bindings: [Set
			[ModelBinding
			  name: 'default'!
			  model: [GrapEThingAddress
			    id: 39!
			  ]

			]

		      ]
		      id: 38!
		    ]

		    [ProjectorFork
		      position: [Point 101 90]
		      id: 30!
		    ]

		    [ProjectorFork
		      position: [Point 141 200]
		      id: 32!
		    ]

		  ]
		  arcs: [OrderedCollection
		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 29!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 30!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 31!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 32!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 30!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 33!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 32!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 34!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 30!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 35!
		      ]

		      route: [OrderedCollection
			[Point 106 191]
		      ]
		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 32!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 36!
		      ]

		      route: [OrderedCollection
			[Point 146 109]
		      ]
		    ]

		    [ProjectorControlFlow
		      indexedOrigin: [GrapEThingAddress
			id: 37!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 38!
		      ]

		      color: [ColorValue
			red: 1.0!
			green: 0.0!
			blue: 0.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		  ]
		  currentConfig: 'default'!
		  id: 21!
		  properties: [GrapEPropertyDictionary
		    key: #break!
		    value: false!
		    key: #windowBounds!
		    value: [Rectangle
		      origin: [Point 393 364]
		      corner: [Point 903 754]
		    ]

		  ]

		]

	      ]
	      id: 19!
	    ]

	    [ProjectorProcedure
	      name: 'write-class-comment'!
	      position: [Point 256 263]
	      archetype: [GrapEThingAddress
		id: 20!
	      ]

	      size: [Point 146 45]
	      components: [PartitionedCollection
		key: #accessories!
		value: [PartitionedCollection
		  key: #ports!
		  value: [OrderedCollection
		    [ProjectorDataPort
		      name: 'class'!
		      position: [Point -73 0]
		      id: 24!
		      properties: [GrapEPropertyDictionary
			key: #direction!
			value: #In!
			key: #showName!
			value: true!
		      ]

		    ]

		    [ProjectorDataPort
		      name: 'port'!
		      position: [Point -73 12]
		      id: 25!
		      properties: [GrapEPropertyDictionary
			key: #direction!
			value: #In!
			key: #showName!
			value: true!
		      ]

		    ]

		  ]
		]

	      ]

	      subdiagrams: [OrderedCollection
		[ProjectorAlterProcedure
		  nodes: [OrderedCollection
		    [GraphParentLabel
		      position: [Point 95 35]
		    ]

		    [ProjectorDataPort
		      position: [Point 50 196]
		      parentCon: [GrapEThingAddress
			id: 24!
		      ]

		    ]

		    [ProjectorDataPort
		      position: [Point 50 234]
		      parentCon: [GrapEThingAddress
			id: 25!
		      ]

		    ]

		  ]
		  currentConfig: 'default'!
		  id: 92!
		  properties: [GrapEPropertyDictionary
		    key: #code!
		    value: [GrapEHyperText
		      textWithLinks: [OrderedCollection '(display ";;; ---" port)
(newline port)
(display ";;; --- TYPE: " port)
(display (name class) port)
(newline port)
(display ";;; --- DESCRIPTION: " port)
(display (description class) port)
(newline port)
(display ";;; ---" port)
(newline port)'!]
		    ]

		    key: #windowBounds!
		    value: [Rectangle
		      origin: [Point 15 30]
		      corner: [Point 525 420]
		    ]

		  ]

		]

	      ]
	      id: 20!
	    ]

	    [ProjectorProcedure
	      name: 'write-class-definition'!
	      position: [Point 272 271]
	      archetype: [GrapEThingAddress
		id: 26!
	      ]

	      size: [Point 168 53]
	      components: [PartitionedCollection
		key: #accessories!
		value: [PartitionedCollection
		  key: #ports!
		  value: [OrderedCollection
		    [ProjectorDataPort
		      name: 'class'!
		      position: [Point -83 2]
		      id: 27!
		      properties: [GrapEPropertyDictionary
			key: #direction!
			value: #In!
			key: #showName!
			value: true!
		      ]

		    ]

		    [ProjectorDataPort
		      name: 'port'!
		      position: [Point -84 16]
		      id: 28!
		      properties: [GrapEPropertyDictionary
			key: #direction!
			value: #In!
			key: #showName!
			value: true!
		      ]

		    ]

		  ]
		]

	      ]

	      subdiagrams: [OrderedCollection
		[ProjectorGraph
		  nodes: [OrderedCollection
		    [ProjectorGraphLabel
		      position: [Point 138 34]
		    ]

		    [ProjectorDataPort
		      position: [Point 81 114]
		      parentCon: [GrapEThingAddress
			id: 27!
		      ]

		      id: 43!
		    ]

		    [ProjectorDataPort
		      position: [Point 77 269]
		      parentCon: [GrapEThingAddress
			id: 28!
		      ]

		      id: 45!
		    ]

		    [ProjectorAlterCode
		      name: 'start'!
		      position: [Point 279 108]
		      size: [Point 116 64]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'class'!
			      position: [Point -58 6]
			      id: 49!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
				key: #showName!
				value: true!
			      ]

			    ]

			    [ProjectorDataPort
			      name: 'port'!
			      position: [Point -56 22]
			      id: 47!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
				key: #showName!
				value: true!
			      ]

			    ]

			  ]
			]

		      ]

		      id: 68!
		      properties: [GrapEPropertyDictionary
			key: #code!
			value: [GrapEHyperText
			  textWithLinks: [OrderedCollection '(display "(define " port)
(display (string-downcase (substitute (name class) " " "-")) port)
(display " (make type (list" port)'!]
			]

		      ]

		    ]

		    [ProjectorFork
		      position: [Point 152 264]
		      id: 46!
		    ]

		    [ProjectorProcedure
		      name: 'superclasses'!
		      position: [Point 264 308]
		      archetype: [GrapEThingAddress
			id: 40!
		      ]

		      size: [Point 102 49]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'class'!
			      position: [Point -51 4]
			      parentCon: [GrapEThingAddress
				id: 41!
			      ]

			      id: 50!
			    ]

			    [ProjectorDataPort
			      name: 'list'!
			      position: [Point 51 2]
			      parentCon: [GrapEThingAddress
				id: 42!
			      ]

			      id: 51!
			    ]

			  ]
			]

		      ]

		      bindings: [Set
			[ModelBinding
			  name: 'default'!
			  model: [GrapEThingAddress
			    id: 76!
			  ]

			]

		      ]
		      id: 82!
		    ]

		    [ProjectorFork
		      position: [Point 173 109]
		      id: 44!
		    ]

		    [ProjectorAlterCode
		      name: 'write-variables'!
		      position: [Point 287 198]
		      size: [Point 134 51]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'class'!
			      position: [Point -67 2]
			      id: 55!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
				key: #showName!
				value: true!
			      ]

			    ]

			    [ProjectorDataPort
			      name: 'port'!
			      position: [Point -67 19]
			      id: 56!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
				key: #showName!
				value: true!
			      ]

			    ]

			  ]
			]

		      ]

		      id: 69!
		      properties: [GrapEPropertyDictionary
			key: #code!
			value: [GrapEHyperText
			  textWithLinks: [OrderedCollection '(for-each
  (lambda (a) 
    (begin
      (display " ''" port)
      (display (string-downcase (substitute (name a) " " "-")) port)))
  (get-property "attributes" class))'!]
			]

		      ]

		    ]

		    [ProjectorAlterCode
		      name: 'finish'!
		      position: [Point 267 386]
		      size: [Point 97 39]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'port'!
			      position: [Point -48 5]
			      id: 63!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
				key: #showName!
				value: true!
			      ]

			    ]

			  ]
			]

		      ]

		      id: 71!
		      properties: [GrapEPropertyDictionary
			key: #code!
			value: [GrapEHyperText
			  textWithLinks: [OrderedCollection '(display ")))" port)
(newline port)'!]
			]

		      ]

		    ]

		    [ProjectorAlterCode
		      name: 'write-superclass'!
		      position: [Point 513 166]
		      size: [Point 136 84]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'superclass'!
			      position: [Point -68 -8]
			      id: 83!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
				key: #showName!
				value: true!
			      ]

			    ]

			    [ProjectorDataPort
			      name: 'port'!
			      position: [Point -68 26]
			      id: 84!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
				key: #showName!
				value: true!
			      ]

			    ]

			  ]
			]

		      ]

		      properties: [GrapEPropertyDictionary
			key: #code!
			value: [GrapEHyperText
			  textWithLinks: [OrderedCollection '(display " " port)
(display (string-downcase (substitute (name superclass) " " "-")) port)'!]
			]

		      ]

		    ]

		    [ProjectorStatementBlock
		      position: [Point 557 271]
		      size: [Point 246 184]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      position: [Point -125 39]
			      id: 86!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
			      ]

			    ]

			    [ProjectorDataPort
			      position: [Point -125 75]
			      id: 87!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
			      ]

			    ]

			  ]
			]

			key: #elements!
			value: [PartitionedCollection
			  key: #statements!
			  value: [SortedCollection
			    [ProjectorAlterCode
			      name: 'write-superclass'!
			      position: [Point -2 44]
			      size: [Point 126 99]
			      components: [PartitionedCollection
				key: #accessories!
				value: [PartitionedCollection
				  key: #ports!
				  value: [OrderedCollection
				    [ProjectorDataPort
				      name: 'superclass'!
				      position: [Point -63 -5]
				      id: 88!
				      properties: [GrapEPropertyDictionary
					key: #direction!
					value: #In!
					key: #showName!
					value: true!
				      ]

				    ]

				    [ProjectorDataPort
				      name: 'port'!
				      position: [Point -63 31]
				      id: 89!
				      properties: [GrapEPropertyDictionary
					key: #direction!
					value: #In!
					key: #showName!
					value: true!
				      ]

				    ]

				  ]
				]

			      ]

			      properties: [GrapEPropertyDictionary
				key: #code!
				value: [GrapEHyperText
				  textWithLinks: [OrderedCollection '(display " " port)
(display (string-downcase (substitute (name superclass) " " "-")) port)'!]
				]

			      ]

			    ]

			  ]
			]

		      ]

		      id: 85!
		    ]

		    [ProjectorAlterCode
		      name: 'end-variables'!
		      position: [Point 274 254]
		      size: [Point 103 34]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'port'!
			      position: [Point -50 3]
			      id: 91!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
				key: #showName!
				value: true!
			      ]

			    ]

			  ]
			]

		      ]

		      id: 90!
		      properties: [GrapEPropertyDictionary
			key: #code!
			value: [GrapEHyperText
			  textWithLinks: [OrderedCollection '(display ") (list" port)'!]
			]

		      ]

		    ]

		  ]
		  arcs: [OrderedCollection
		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 43!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 44!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 45!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 46!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 46!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 47!
		      ]

		      route: [OrderedCollection
			[Point 157 130]
		      ]
		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 44!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 49!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 44!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 50!
		      ]

		      route: [OrderedCollection
			[Point 178 312]
		      ]
		      properties: [GrapEPropertyDictionary
			key: #trace!
			value: true!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 44!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 55!
		      ]

		      route: [OrderedCollection
			[Point 178 200]
		      ]
		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 46!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 56!
		      ]

		      route: [OrderedCollection
			[Point 157 217]
		      ]
		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 46!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 63!
		      ]

		      route: [OrderedCollection
			[Point 157 391]
		      ]
		    ]

		    [ProjectorControlFlow
		      indexedOrigin: [GrapEThingAddress
			id: 68!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 69!
		      ]

		      color: [ColorValue
			red: 1.0!
			green: 0.0!
			blue: 0.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		    [ProjectorControlFlow
		      indexedOrigin: [GrapEThingAddress
			id: 69!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 90!
		      ]

		      color: [ColorValue
			red: 1.0!
			green: 0.0!
			blue: 0.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 51!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 86!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #transfer!
			value: #simple!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 46!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 87!
		      ]

		      route: [OrderedCollection
			[Point 157 346]
		      ]
		      properties: [GrapEPropertyDictionary
			key: #transfer!
			value: #simple!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 86!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 88!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #transfer!
			value: #reduce!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 87!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 89!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #transfer!
			value: #maintain!
		      ]

		    ]

		    [ProjectorControlFlow
		      indexedOrigin: [GrapEThingAddress
			id: 85!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 71!
		      ]

		      color: [ColorValue
			red: 1.0!
			green: 0.0!
			blue: 0.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 46!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 91!
		      ]

		      route: [OrderedCollection
			[Point 157 257]
		      ]
		    ]

		    [ProjectorControlFlow
		      indexedOrigin: [GrapEThingAddress
			id: 90!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 85!
		      ]

		      color: [ColorValue
			red: 1.0!
			green: 0.0!
			blue: 0.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		  ]
		  currentConfig: 'default'!
		  id: 39!
		  properties: [GrapEPropertyDictionary
		    key: #break!
		    value: false!
		    key: #windowBounds!
		    value: [Rectangle
		      origin: [Point 39 255]
		      corner: [Point 990 806]
		    ]

		  ]

		]

	      ]
	      id: 26!
	    ]

	    [ProjectorProcedure
	      name: 'dc-parent'!
	      position: [Point 249 247]
	      archetype: [GrapEThingAddress
		id: 57!
	      ]

	      size: [Point 125 60]
	      components: [PartitionedCollection
		key: #accessories!
		value: [PartitionedCollection
		  key: #ports!
		  value: [OrderedCollection
		    [ProjectorDataPort
		      name: 'parent'!
		      position: [Point 63 12]
		      id: 58!
		      properties: [GrapEPropertyDictionary
			key: #direction!
			value: #Out!
			key: #showName!
			value: true!
		      ]

		    ]

		    [ProjectorDataPort
		      name: 'genspec'!
		      position: [Point -62 12]
		      id: 59!
		      properties: [GrapEPropertyDictionary
			key: #direction!
			value: #In!
			key: #showName!
			value: true!
		      ]

		    ]

		  ]
		]

	      ]

	      subdiagrams: [OrderedCollection
		[ProjectorAlterProcedure
		  nodes: [OrderedCollection
		    [GraphParentLabel
		      position: [Point 60 35]
		    ]

		    [ProjectorDataPort
		      position: [Point 384 226]
		      parentCon: [GrapEThingAddress
			id: 58!
		      ]

		    ]

		    [ProjectorDataPort
		      position: [Point 50 224]
		      parentCon: [GrapEThingAddress
			id: 59!
		      ]

		    ]

		  ]
		  currentConfig: 'default'!
		  properties: [GrapEPropertyDictionary
		    key: #code!
		    value: [GrapEHyperText
		      textWithLinks: [OrderedCollection '(let* (  (arcs (select (outgoing-arcs genspec))
                            (lambda (a) (is-a? a domaingslink)))) )
      (if (null? arcs) nil (destination (car arcs)))'!]
		    ]

		    key: #windowBounds!
		    value: [Rectangle
		      origin: [Point 15 30]
		      corner: [Point 525 420]
		    ]

		  ]

		]

	      ]
	      id: 57!
	    ]

	    [ProjectorProcedure
	      name: 'gs-parents'!
	      position: [Point 256 241]
	      archetype: [GrapEThingAddress
		id: 60!
	      ]

	      size: [Point 119 52]
	      components: [PartitionedCollection
		key: #accessories!
		value: [PartitionedCollection
		  key: #ports!
		  value: [OrderedCollection
		    [ProjectorDataPort
		      name: 'class'!
		      position: [Point -59 9]
		      id: 61!
		      properties: [GrapEPropertyDictionary
			key: #direction!
			value: #In!
			key: #showName!
			value: true!
		      ]

		    ]

		    [ProjectorDataPort
		      name: 'parents'!
		      position: [Point 60 9]
		      id: 62!
		      properties: [GrapEPropertyDictionary
			key: #direction!
			value: #Out!
			key: #showName!
			value: true!
		      ]

		    ]

		  ]
		]

	      ]

	      subdiagrams: [OrderedCollection
		[ProjectorAlterProcedure
		  nodes: [OrderedCollection
		    [GraphParentLabel
		      position: [Point 63 35]
		    ]

		    [ProjectorDataPort
		      position: [Point 50 221]
		      parentCon: [GrapEThingAddress
			id: 61!
		      ]

		    ]

		    [ProjectorDataPort
		      position: [Point 384 220]
		      parentCon: [GrapEThingAddress
			id: 62!
		      ]

		    ]

		  ]
		  currentConfig: 'default'!
		  properties: [GrapEPropertyDictionary
		    key: #code!
		    value: [GrapEHyperText
		      textWithLinks: [OrderedCollection '(map destination
        (select (outgoing-arcs class)
                   (lambda (a) (is-a? a domaingslink))))'!]
		    ]

		    key: #windowBounds!
		    value: [Rectangle
		      origin: [Point 15 30]
		      corner: [Point 525 420]
		    ]

		  ]

		]

	      ]
	      id: 60!
	    ]

	    [ProjectorProcedure
	      name: 'superclasses'!
	      position: [Point 245 250]
	      archetype: [GrapEThingAddress
		id: 40!
	      ]

	      size: [Point 102 49]
	      components: [PartitionedCollection
		key: #accessories!
		value: [PartitionedCollection
		  key: #ports!
		  value: [OrderedCollection
		    [ProjectorDataPort
		      name: 'class'!
		      position: [Point -51 11]
		      id: 41!
		      properties: [GrapEPropertyDictionary
			key: #direction!
			value: #In!
			key: #showName!
			value: true!
		      ]

		    ]

		    [ProjectorDataPort
		      name: 'list'!
		      position: [Point 51 12]
		      id: 42!
		      properties: [GrapEPropertyDictionary
			key: #direction!
			value: #Out!
			key: #showName!
			value: true!
		      ]

		    ]

		  ]
		]

	      ]

	      subdiagrams: [OrderedCollection
		[ProjectorAlterProcedure
		  nodes: [OrderedCollection
		    [GraphParentLabel
		      position: [Point 70 35]
		    ]

		    [ProjectorDataPort
		      position: [Point 50 228]
		      parentCon: [GrapEThingAddress
			id: 41!
		      ]

		    ]

		    [ProjectorDataPort
		      position: [Point 384 231]
		      parentCon: [GrapEThingAddress
			id: 42!
		      ]

		    ]

		  ]
		  currentConfig: 'default'!
		  id: 76!
		  properties: [GrapEPropertyDictionary
		    key: #code!
		    value: [GrapEHyperText
		      textWithLinks: [OrderedCollection '(map dc-parent (gs-parents class))'!]
		    ]

		    key: #windowBounds!
		    value: [Rectangle
		      origin: [Point 15 30]
		      corner: [Point 525 420]
		    ]

		  ]

		]

	      ]
	      id: 40!
	    ]

	  ]
	  id: 2!
	  properties: [GrapEPropertyDictionary
	    key: #windowBounds!
	    value: [Rectangle
	      origin: [Point 15 191]
	      corner: [Point 579 604]
	    ]

	    key: #rootCategory!
	    value: [GrapECategory
	      id: 3!
	      properties: [GrapEPropertyDictionary
		key: #name!
		value: '/'!
	      ]

	    ]

	  ]

	]

      ]
    ]

    [ProjectorGraphLabel
      position: [Point 50 34]
    ]

    [ProjectorProcedure
      name: 'generate-alter'!
      position: [Point 144 107]
      archetype: [GrapEThingAddress
	id: 4!
      ]

      size: [Point 118 41]
      components: [PartitionedCollection
	key: #accessories!
	value: [PartitionedCollection
	  key: #ports!
	  value: [OrderedCollection
	    [ProjectorDataPort
	      name: 'model'!
	      position: [Point -58 9]
	      parentCon: [GrapEThingAddress
		id: 65!
	      ]

	    ]

	  ]
	]

      ]

      bindings: [Set
	[ModelBinding
	  name: 'default'!
	  model: [GrapEThingAddress
	    id: 64!
	  ]

	]

      ]
    ]

  ]
  currentConfig: 'default'!
  id: 77!
  properties: [GrapEPropertyDictionary
    key: #initialOpenGraphs!
    value: [OrderedCollection
      [GrapEThingAddress
	id: 77!
      ]

    ]
    key: #configurations!
    value: [SortedCollection 'default'!]
    key: #windowBounds!
    value: [Rectangle
      origin: [Point 348 342]
      corner: [Point 793 708]
    ]

    key: #entry!
    value: 'generate-alter'!
  ]

  idCntr: 97!
]
