# DoME 5.0 model; type: Projector Diagram
[ProjectorGraph
  nodes: [OrderedCollection
    [ProjectorShelfHolder
      name: 'Shelf Holder'!
      position: [Point 100 100]
      subdiagrams: [OrderedCollection
	[ProjectorArchetypeGraph
	  name: 'Archetypes'!
	  nodes: [OrderedCollection
	    [GraphParentLabel
	      position: [Point 50 35]
	    ]

	    [ProjectorProcedure
	      name: 'coad-yourdon-from'!
	      position: [Point 143 111]
	      archetype: [GrapEThingAddress
		id: 4!
	      ]

	      components: [PartitionedCollection
		key: #accessories!
		value: [PartitionedCollection
		  key: #ports!
		  value: [OrderedCollection
		    [ProjectorDataPort
		      name: 'graph'!
		      position: [Point -16 -14]
		      id: 5!
		      properties: [GrapEPropertyDictionary
			key: #direction!
			value: #In!
		      ]

		    ]

		  ]
		]

	      ]

	      subdiagrams: [OrderedCollection
		[ProjectorGraph
		  nodes: [OrderedCollection
		    [ProjectorGraphLabel
		      position: [Point 79 286]
		    ]

		    [ProjectorDataPort
		      position: [Point 43 154]
		      parentCon: [GrapEThingAddress
			id: 5!
		      ]

		      id: 12!
		    ]

		    [ProjectorProcedure
		      name: 'select'!
		      position: [Point 231 125]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'Port1'!
			      position: [Point -20 -2]
			      id: 17!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
			      ]

			    ]

			    [ProjectorDataPort
			      name: 'Port2'!
			      position: [Point -1 -14]
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
			      ]

			    ]

			    [ProjectorDataPort
			      position: [Point 20 0]
			      id: 23!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #Out!
			      ]

			    ]

			  ]
			]

		      ]

		    ]

		    [ProjectorProcedure
		      name: 'nodes'!
		      position: [Point 148 123]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'Port1'!
			      position: [Point -21 0]
			      id: 14!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
			      ]

			    ]

			    [ProjectorDataPort
			      position: [Point 21 0]
			      id: 16!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #Out!
			      ]

			    ]

			  ]
			]

		      ]

		    ]

		    [ProjectorProcedure
		      name: 'arcs'!
		      position: [Point 146 183]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'Port1'!
			      position: [Point -16 0]
			      id: 15!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
			      ]

			    ]

			    [ProjectorDataPort
			      position: [Point 17 0]
			      id: 32!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #Out!
			      ]

			    ]

			  ]
			]

		      ]

		    ]

		    [ProjectorFork
		      position: [Point 98 155]
		      id: 13!
		    ]

		    [ProjectorProcedure
		      name: 'new-top-model'!
		      position: [Point 311 28]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'Port1'!
			      position: [Point -46 0]
			      id: 19!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
			      ]

			    ]

			    [ProjectorDataPort
			      position: [Point 46 0]
			      id: 20!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #Out!
			      ]

			    ]

			  ]
			]

		      ]

		    ]

		    [ProjectorConstant
		      position: [Point 176 28]
		      id: 18!
		      properties: [GrapEPropertyDictionary
			key: #value!
			value: 'DomainModelPage'!
		      ]

		    ]

		    [ProjectorProcedure
		      name: 'edit'!
		      position: [Point 444 28]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'Port1'!
			      position: [Point -15 0]
			      id: 22!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
			      ]

			    ]

			    [ProjectorDataPort
			      position: [Point 16 0]
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #Out!
			      ]

			    ]

			  ]
			]

		      ]

		    ]

		    [ProjectorFork
		      position: [Point 394 28]
		      id: 21!
		    ]

		    [ProjectorProcedure
		      name: 'map-objects'!
		      position: [Point 340 127]
		      archetype: [GrapEThingAddress
			id: 6!
		      ]

		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      position: [Point -19 -14]
			      parentCon: [GrapEThingAddress
				id: 8!
			      ]

			      id: 30!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
			      ]

			    ]

			    [ProjectorDataPort
			      position: [Point -37 0]
			      parentCon: [GrapEThingAddress
				id: 9!
			      ]

			      id: 24!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
			      ]

			    ]

			    [ProjectorDataPort
			      position: [Point 37 0]
			      parentCon: [GrapEThingAddress
				id: 10!
			      ]

			      id: 31!
			    ]

			    [ProjectorDataPort
			      position: [Point 10 -14]
			      parentCon: [GrapEThingAddress
				id: 11!
			      ]

			      id: 27!
			    ]

			  ]
			]

		      ]

		      bindings: [Set
			[ModelBinding
			  name: 'default'!
			  model: [GrapEThingAddress
			    id: 7!
			  ]

			]

		      ]
		    ]

		    [ProjectorProcedure
		      name: 'make-dictionary'!
		      position: [Point 205 60]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      position: [Point 47 0]
			      id: 28!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #Out!
			      ]

			    ]

			  ]
			]

		      ]

		    ]

		    [ProjectorMerge
		      position: [Point 333 263]
		      id: 25!
		    ]

		    [ProjectorProcedure
		      name: 'display-errors'!
		      position: [Point 332 303]
		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'Port1'!
			      position: [Point 1 -14]
			      id: 26!
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #In!
			      ]

			    ]

			    [ProjectorDataPort
			      position: [Point 42 0]
			      properties: [GrapEPropertyDictionary
				key: #direction!
				value: #Out!
			      ]

			    ]

			  ]
			]

		      ]

		    ]

		    [ProjectorFork
		      position: [Point 283 77]
		      id: 29!
		    ]

		    [ProjectorProcedure
		      name: 'map-objects'!
		      position: [Point 265 185]
		      archetype: [GrapEThingAddress
			id: 6!
		      ]

		      components: [PartitionedCollection
			key: #accessories!
			value: [PartitionedCollection
			  key: #ports!
			  value: [OrderedCollection
			    [ProjectorDataPort
			      name: 'dict'!
			      position: [Point -3 -12]
			      parentCon: [GrapEThingAddress
				id: 8!
			      ]

			      id: 34!
			    ]

			    [ProjectorDataPort
			      name: 'object'!
			      position: [Point -36 0]
			      parentCon: [GrapEThingAddress
				id: 9!
			      ]

			      id: 33!
			    ]

			    [ProjectorDataPort
			      name: 'errors'!
			      position: [Point 37 3]
			      parentCon: [GrapEThingAddress
				id: 10!
			      ]

			      id: 36!
			    ]

			    [ProjectorDataPort
			      name: 'container-thing'!
			      position: [Point 21 -12]
			      parentCon: [GrapEThingAddress
				id: 11!
			      ]

			      id: 35!
			    ]

			  ]
			]

		      ]

		      bindings: [Set
			[ModelBinding
			  name: 'default'!
			  model: [GrapEThingAddress
			    id: 7!
			  ]

			]

		      ]
		    ]

		  ]
		  arcs: [OrderedCollection
		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 12!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 13!
		      ]

		      color: [ColorValue
			red: 0.0!
			green: 0.0!
			blue: 1.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 13!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 14!
		      ]

		      color: [ColorValue
			red: 0.0!
			green: 0.0!
			blue: 1.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 13!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 15!
		      ]

		      color: [ColorValue
			red: 0.0!
			green: 0.0!
			blue: 1.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 16!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 17!
		      ]

		      color: [ColorValue
			red: 0.0!
			green: 0.0!
			blue: 1.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 18!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 19!
		      ]

		      color: [ColorValue
			red: 0.0!
			green: 0.0!
			blue: 1.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 20!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 21!
		      ]

		      color: [ColorValue
			red: 0.0!
			green: 0.0!
			blue: 1.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 21!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 22!
		      ]

		      color: [ColorValue
			red: 0.0!
			green: 0.0!
			blue: 1.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 23!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 24!
		      ]

		      color: [ColorValue
			red: 0.0!
			green: 0.0!
			blue: 1.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 25!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 26!
		      ]

		      color: [ColorValue
			red: 0.0!
			green: 0.0!
			blue: 1.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 21!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 27!
		      ]

		      color: [ColorValue
			red: 0.0!
			green: 0.0!
			blue: 1.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 28!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 29!
		      ]

		      color: [ColorValue
			red: 0.0!
			green: 0.0!
			blue: 1.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 29!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 30!
		      ]

		      color: [ColorValue
			red: 0.0!
			green: 0.0!
			blue: 1.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 31!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 25!
		      ]

		      route: [OrderedCollection
			[Point 420 127]
			[Point 420 231]
			[Point 338 231]
		      ]
		      color: [ColorValue
			red: 0.0!
			green: 0.0!
			blue: 1.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 32!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 33!
		      ]

		      color: [ColorValue
			red: 0.0!
			green: 0.0!
			blue: 1.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 29!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 34!
		      ]

		      color: [ColorValue
			red: 0.0!
			green: 0.0!
			blue: 1.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 21!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 35!
		      ]

		      route: [OrderedCollection
			[Point 394 156]
			[Point 286 156]
		      ]
		      color: [ColorValue
			red: 0.0!
			green: 0.0!
			blue: 1.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		    [ProjectorDataFlow
		      indexedOrigin: [GrapEThingAddress
			id: 36!
		      ]

		      indexedDestination: [GrapEThingAddress
			id: 25!
		      ]

		      route: [OrderedCollection
			[Point 330 188]
		      ]
		      color: [ColorValue
			red: 0.0!
			green: 0.0!
			blue: 1.0!
		      ]

		      properties: [GrapEPropertyDictionary
			key: #frozenColor!
			value: true!
		      ]

		    ]

		  ]
		  currentConfig: 'default'!
		  id: 1!
		  properties: [GrapEPropertyDictionary
		    key: #windowBounds!
		    value: [Rectangle
		      origin: [Point 8 44]
		      corner: [Point 636 455]
		    ]

		  ]

		]

	      ]
	      id: 4!
	    ]

	    [ProjectorProcedure
	      name: 'map-objects'!
	      position: [Point 340 127]
	      archetype: [GrapEThingAddress
		id: 6!
	      ]

	      components: [PartitionedCollection
		key: #accessories!
		value: [PartitionedCollection
		  key: #ports!
		  value: [OrderedCollection
		    [ProjectorDataPort
		      name: 'dict'!
		      position: [Point -3 -14]
		      id: 8!
		      properties: [GrapEPropertyDictionary
			key: #direction!
			value: #In!
		      ]

		    ]

		    [ProjectorDataPort
		      name: 'objects'!
		      position: [Point -37 0]
		      id: 9!
		      properties: [GrapEPropertyDictionary
			key: #direction!
			value: #In!
		      ]

		    ]

		    [ProjectorDataPort
		      name: 'errors'!
		      position: [Point 37 3]
		      id: 10!
		      properties: [GrapEPropertyDictionary
			key: #direction!
			value: #Out!
		      ]

		    ]

		    [ProjectorDataPort
		      name: 'container-thing'!
		      position: [Point 21 -14]
		      id: 11!
		      properties: [GrapEPropertyDictionary
			key: #direction!
			value: #In!
		      ]

		    ]

		  ]
		]

	      ]

	      subdiagrams: [OrderedCollection
		[ProjectorGraph
		  nodes: [OrderedCollection
		    [ProjectorGraphLabel
		      position: [Point 58 35]
		    ]

		    [ProjectorDataPort
		      position: [Point 81 238]
		      parentCon: [GrapEThingAddress
			id: 8!
		      ]

		    ]

		    [ProjectorDataPort
		      position: [Point 87 110]
		      parentCon: [GrapEThingAddress
			id: 9!
		      ]

		    ]

		    [ProjectorDataPort
		      position: [Point 475 125]
		      parentCon: [GrapEThingAddress
			id: 10!
		      ]

		    ]

		    [ProjectorDataPort
		      position: [Point 83 166]
		      parentCon: [GrapEThingAddress
			id: 11!
		      ]

		    ]

		  ]
		  currentConfig: 'default'!
		  id: 7!
		  properties: [GrapEPropertyDictionary
		    key: #windowBounds!
		    value: [Rectangle
		      origin: [Point 33 162]
		      corner: [Point 493 552]
		    ]

		  ]

		]

	      ]
	      id: 6!
	    ]

	  ]
	  id: 2!
	  properties: [GrapEPropertyDictionary
	    key: #originOffset!
	    value: [Point 270 15]
	    key: #windowBounds!
	    value: [Rectangle
	      origin: [Point 291 389]
	      corner: [Point 729 621]
	    ]

	    key: #rootCategory!
	    value: [GrapECategory
	      id: 3!
	      properties: [GrapEPropertyDictionary
		key: #subCategories!
		value: [Set
		  [GrapECategory
		    id: 37!
		    properties: [GrapEPropertyDictionary
		      key: #subCategories!
		      value: [Set
			[GrapECategory
			  id: 38!
			  properties: [GrapEPropertyDictionary
			    key: #smalltalkClass!
			    value: #ProjectorProcedure!
			    key: #name!
			    value: 'Procedure'!
			  ]

			]

		      ]
		      key: #name!
		      value: 'types'!
		    ]

		  ]

		]
		key: #name!
		value: '/'!
	      ]

	    ]

	  ]

	]

      ]
    ]

    [ProjectorGraphLabel
      position: [Point 50 35]
    ]

    [ProjectorProcedure
      name: 'coad-yourdon-from'!
      position: [Point 143 111]
      archetype: [GrapEThingAddress
	id: 4!
      ]

      components: [PartitionedCollection
	key: #accessories!
	value: [PartitionedCollection
	  key: #ports!
	  value: [OrderedCollection
	    [ProjectorDataPort
	      name: 'graph'!
	      position: [Point -16 -14]
	      parentCon: [GrapEThingAddress
		id: 5!
	      ]

	      properties: [GrapEPropertyDictionary
		key: #direction!
		value: #In!
	      ]

	    ]

	  ]
	]

      ]

      bindings: [Set
	[ModelBinding
	  name: 'default'!
	  model: [GrapEThingAddress
	    id: 1!
	  ]

	]

      ]
    ]

  ]
  currentConfig: 'default'!
  id: 39!
  properties: [GrapEPropertyDictionary
    key: #initialOpenGraphs!
    value: [OrderedCollection
      [GrapEThingAddress
	id: 39!
      ]

    ]
    key: #configurations!
    value: [SortedCollection 'default'!]
    key: #windowBounds!
    value: [Rectangle
      origin: [Point 244 259]
      corner: [Point 595 571]
    ]

  ]

  idCntr: 39!
]
